#ifndef _CPARAMS_H
#define _CPARAMS_H

static const int  DEFAULT_GAPO 		= 11;
static const int  DEFAULT_GAPE 		= 2;
static const int  MAX_PATH_LENGTH 	= 1024;
static const int  DEFAULT_SHUFFLE 	= 1000;
static const int  DEFAULT_PSSM 		= 1;
static const int  DEFAULT_CSV		= 1;
static const int  DEFAULT_THREADS	= 1;
static const int DEFAULT_PARA_TYPE	= 0;

class CParams
{
public:
	CParams();
	~CParams();

	void	getSysTime(double * dtime);
	void 	printUsage(); 
	bool	parseParams(int argc, char* argv[]);
	
	char*	getQueryFile() { return seqQueryFile;}
	char*	getMatrixFilePath() { return MatrixFilePath;}	
	char*	getDBFile() { return DBFile;}
	char*	getClsFile(){ return seqClsFile;}
	int		getMatrixType() { return mtype; }
	int		getEstimateType() { return etype; }	
	int		getShuffle() { return shuffles_ML;}
private:
	void iniStr(char* s, int len){
		for(int i = 0; i < len; i++) 
			s[i]='\0';
	}
	
	int 	etype; /* the type of estimation */
	int		mtype; /* the type of matrix */
	char 	MatrixFilePath[MAX_PATH_LENGTH]; //just path or filename for PSSM or SSM
	char 	DBFile[MAX_PATH_LENGTH]; //specific file
	char 	seqQueryFile[MAX_PATH_LENGTH]; //specific file
	char 	seqClsFile [MAX_PATH_LENGTH];
	
	int shuffles_ML;

};
#endif

