
#ifndef _GAP3PSSM_COMP_H
#define _GAP3PSSM_COMP_H
#include <gap3PSSM.comp.h>

#define  MATCHSC    10   /* match score */
#define  LINELEN    60   /* lenght of an output line */



void AllocateArrays(int M, int N);

void extractPSSMFromFile(int vv[][128], char *filename, int len);

void GetPSSM(
			char* pssmFile,		/* substition table */
			int   qq,		/* gap open */
			int   rr,		/* gap extension */
			int   ppay,		/* difference block */
			int  M, int N      /* their lengths */
			);
void GetSM(
			char smFile[],		/* substition table */
			int   qq,			/* gap open */
			int   rr,			/* gap extension */
			int   ppay,			/* difference block */
			int  M, int N       /* their lengths */
			);
			
void SM2PSSM(char seq[], int M);

		
int UseGAP3(char A[], char B[],          /* sequences */
			int  M, int N             	/* their lengths */
			);

void ScoreOnly(
		char* A, char* B, 
		int M, int N, 
		int c00, int d00, 
		int h00, int cmn, 
		int dmn, int hmn
		);

void FindEndPoints(
		char* A, char* B, 
		int M, int N, 
		int c00, int d00, 
		int h00, int cmn, 
		int dmn, int hmn
		);

int diff2(
		char* A, char* B, 
		int M, int N, 
		int c00, int d00, int h00, 
		int cmn, int dmn, int hmn
		);

void display(
		char A[], char B[],		/* sequences */
		int M, int N,		/* their lengths */
		int S[],		/* list of operations */
		short MD[],		/* list of major difference flags */
		int AP, int BP		/* start positions in sequences */
		);

void FreeArrays();
			
#endif

