/*
	AUTHOR: YUHONG ZHANG, Ankit Agrawal

	June.2011
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <mpi.h>
#include <iostream>
using namespace std;
#include "MPIPairwiseStatSig.h"
#include "CParams.h"
#include "generic.h"
			
int main(int argc,char* argv[])
{
	CParams params;
	StatSig* StatSigMPI_ML = NULL;
	
	int nProcessors, //no. of processors
		pRank;		//rank of processor
	
	MPI::Init(argc, argv);

	nProcessors = MPI::COMM_WORLD.Get_size();
	pRank 		= MPI::COMM_WORLD.Get_rank();

	//parse parameters
	if(!params.parseParams(argc, argv)){
		MPI::Finalize();
		return 0;
	}
	
	StatSigMPI_ML = new StatSig(&params);

	if(StatSigMPI_ML){
		StatSigMPI_ML->run();		
	}
	
	if (pRank == 0) {		
		StatSigMPI_ML->PrintResult();
	}
	
	delete StatSigMPI_ML;
	
	MPI::Finalize();
	return 0;	
}
